

/*
Header Kurs 2020
Version "12.02.2020"
Header Bibliothek Browser: 
K:\PHY\elfort\0000_Kurs2020_ATMega328_Progs\AT328-Main_LEER
file:///C:/WinAVR-20100110/doc/avr-libc/avr-libc-user-manual/index.html
Controller Defines File Explorer: C:\WinAVR-20100110\avr\include\avr\iom328p.h
*/
#ifndef MAIN_HEADER  //Prevents multiple includes
 #define MAIN_HEADER	

#define MCA_NOBRAIN_MSG "*Habe kein Hirn*"
#define MCA_YOUROWN_MSG "*Benutze Deins*"

// =============================================================
#define UART_USE_ENABLED
#define I2C_USED
#define I2C_LCD_USED
#define INT0_SWITCH_PIN_USED
//#define ADC_USED
#define MAX7219_USED
//#define SHIFT74595_USED
//#define  BCD_4X_USED
//#define RC5_IR_USED
//#define MULTIPWM_USED
#define MORSE_TX_USED
// =============================================================

#include <ctype.h>
#include <inttypes.h>
#include <avr\pgmspace.h>
#include <avr\io.h>
//#include <stdio.h>

#include <math.h>
#include <stdlib.h>
//#include <stdarg.h>
#include <avr\interrupt.h>  // obsolete #include <avr\signal.h>
#include <avr\wdt.h>
#include <util\delay.h>	//_delay_loop_1 _delay_loop_2 delay_ms
#include "debug.h"
#include "uartATM328.h"
#include "TextService.h"
#include "Befehle.h"
#include "max7219.h"
#include "74-595_Out.h"
//#include "4xBCD-Multiplex.h"
//#include "TextService.h"
#include "I2cmaster.h"
#include "PCF8574.h"
#include "i2clcd.h"
//#include "MixPort.h"
//#include "StepMotor.h"
//#include "rc5_ATM328.h"
//#include "MY_RC5_Func_ATM328.h"
//#include "MultiPWM.h"
	//#include "MorseTabelle_8Bit.h"
#include "Morse_8Bit_Simpel.h"
#include "RingBuf.h"
#include "MorseTx.h"

#define _CLEARMASK_	&=	//Und= lscht Bits OHNE Komplement
#define _CLEARBIT_	&=~	//Und=~ lscht Bits mit Komplement
#define _SETBIT_	|=	//Oder= setzts Bits
#define _TOOGLEBIT_	^=  //XOR= TOGGLE  BITS  Wie ein Wechselschalter
#define _UNGLEICH_	!=
#define _AND_LOG_	&&
#define _OR_LOG_	||
#define _AND_BIN_	&
#define _OR_BIN_	|

#define DISABLE_ALL_PULLUP()	(SFIOR |= _BV(PUD));
#define ENABLE_ALLUP_SCL()		(SFIOR &= ~(_BV(PUD)));

#define LED5		(1<<5)
#define SETLED()	(PORTB |= LED5)
#define CLRLED()	(PORTB &= ~LED5)

// GLOBALE VARIABLEN 
//CONSTANT ARRAYs IN .TEXT = ROM ARREA   .DATA IST SRAM !! .BSS SRA

	#define T0_64DIV_SELECTED
#ifdef T0_256DIV_SELECTED
#define TICKS_3000MS	750
#define TICKS_2000MS	500
#define TICKS_1000MS	250
#define TICKS_100MS		25
#define TICKS_28MS		7
#define TICKS_25HZ		10
#endif

#ifdef T0_64DIV_SELECTED
#define TICKS_3000MS	3000
#define TICKS_2000MS	2000
#define TICKS_1000MS	1000
#define TICKS_100MS		100
#define TICKS_25MS		25
#define TICKS_10HZ		10
#endif

#define TICKS_RAMPENSPEED (250/4)

typedef struct
{
unsigned char TICK_3SEC_Flag	: 1;
unsigned char TICK_1000MS_Flag	: 1;
unsigned char TICK_100MS_Flag	: 1;
unsigned char TICK_25MS_Flag	: 1;
unsigned char Geschwaetzig		: 1;
unsigned char AutoMorse_Flag : 1;
unsigned char TX_Morse_Sofort_Flag : 1;
}BIT_FIELD_TYPE;
//gstFlags.

//=========================================================
//PORT_ASSIGMNEMTS

// ========================================================
// *******   PORTB   ****************

#define INTERN_LED_BIT		(1 << PB5)					// Shiftleft "1" 5 mal
#define INTERN_LED_PORT		PORTB
#define INTERN_LED_INIT()	(DDRB |= INTERN_LED_BIT)	// OR = 
#define INTERN_LED_ON()		(PORTB |= INTERN_LED_BIT)	// OR =
#define INTERN_LED_OFF()	(PORTB &= ~INTERN_LED_BIT)	// AND = Komplement
#define INTERN_LED_TOGGLE()	(PORTB ^= INTERN_LED_BIT)	// XOR =

extern volatile uint32_t gu32Ticks;
extern volatile BIT_FIELD_TYPE gstFlags;
extern void LCDShiftChars( uint8_t u8Char );
#endif //MAIN_HEADER
