
//https://www.mikrocontroller.net/articles/Port-Expander_PCF8574

// den Bus noch initialiesieren. Bei mir am Portc. SCL =PC.0 SDA = PC.1

//Folgende Adresse wird schon 8 Bit codet
/*
codiert ->  
| 0 | 1 | 0 | 0 | A2 | A1 | A0 | R/W |  == 64 DEZ = 0x40
7-Bit  codiert als linksbndig 8 Bit + r/W 
*/


#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
#include <stdlib.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>
#include "PCF8574.h"
#include "i2cmaster.h"


void PCF8574_Init(void)
{
i2c_init();
i2c_start_wait(  PORTEXPANDER_PCF8574_ADR_PREFIX + I2C_WRITE );
i2c_write(  0XA5 ); // If( 2c_write(   ........
i2c_stop();
}

//PCF8574_Init( LCD_PCF8574_ADR_PREFIX );  //LCD
//PCF8574_Init( PORTEXPANDER_PCF8574_ADR_PREFIX);  //LEDLEISTE


/*
//ANWENDUNGSBEISPIEL
void PCF8574_Init(uint8_t u8Adr )
{
static uint8_t u8Count;
i2c_start_wait(u8Adr + I2C_WRITE );
u8Count++;
u8Count %= 8;

if( i2c_write( (1<< u8Count) ) )
	{
	//uart_puts_p( PSTR("Write failed") ); 
	//uart_puts_p( PSTR(" Byte=") ); 
	//uart_puts(ByteToBin( (1<< u8Count) ) );
	//uart_putc( 13 );
	};
	
i2c_stop ();
};
*/

